Skip to main content
ActionKit Tools API provides our complete library of pre-built tools (actions in third-party systems) to expose as capabilities for AI agents, workflow builders, or other front-end functions that require integration data.

API Usage

Base URL
Authentication To authenticate to ActionKit API, present a Bearer token with the Paragon User Token (a JWT):
This is the same token that you used to call paragon.authenticate with the Paragon SDK. See examples in Installing the SDK.
If you are using JWT Permissions to control access, your Paragon User Token must include the actionkit permission to make ActionKit API requests.

Pagination

Many list and search actions in ActionKit accept a paginationParameters object as part of the request parameters. When the result set exceeds a single page, the response includes a pageCursor (or equivalent token) that you pass in the next request to retrieve the following page. A typical pagination flow looks like this:
  1. Call an action without any pagination parameters to get the first page.
  2. Check the response for a pagination cursor or token (e.g. nextPageCursor).
  3. If a cursor is present, call the action again with the cursor in paginationParameters.
  4. Repeat until no cursor is returned.
Example: Paginating Asana projects
Paragon standardizes vendor-specific pagination mechanics into a few patterns: You can find the specific pagination parameters available for each action in the Actions Reference. Actions that support pagination include paginationParameters in their input schema.

File Uploads

Actions that accept a file input to upload a file to an integration (for example, Google Drive: Save File and Box: Save File) will need to be encoded as part of the JSON payload provided when the Action is run.
  1. Hex-encode the file With the file contents you want to upload, hex-encode of the bytes file that you intend to upload.
  2. Construct a File object A File object is a JSON object that represents a File to upload. You must provide three standard fields:
    File object

Examples

Here are some end-to-end examples of uploading a file with ActionKit in a few different client languages:

Limitations

ActionKit limits incoming request body payloads to 10 MB. Because of the required hex encoding, uploaded files are effectively limited to 5 MB. For larger file sizes, use the Proxy API to upload to the integration directly.

Using Multi-Account Authorization

Multi-Account Authorization is a set of SDK options that enables you to connect multiple accounts of the same integration type for a Connected User. You can use Multi-Account Authorization with ActionKit by specifying a credential with a header of X-Paragon-Credential.
REST API